﻿'Birthday manager by Philipp Erler
'Written in 2011
'Last change 29 | 01 | 2011
'You may change and distribute this code as you want
'You may not sell this program, this code or parts of it
'########################################################
'Manage birthdays with this tool
'Get a message if someone's birthday is today 
'########################################################

Imports Microsoft.Win32.Registry
Imports System.Security.Permissions

Public Class frmBirthdayMessenger

    Structure BirthdayInfo
        Public name As String
        Public preName As String
        Public birthDay As Date
        Public info As String

        Public Sub New(ByVal name As String, ByVal preName As String, ByVal birthday As Date, ByVal info As String)
            Me.name = name
            Me.preName = preName
            Me.birthDay = birthday
            Me.info = info
        End Sub
    End Structure

    Public birthdays As New List(Of BirthdayInfo)

    Dim lastDate As Date = New Date(0)

    Private Sub BeendenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BeendenToolStripMenuItem.Click
        End
    End Sub

    'add registry entry to start program when windows starts
    Private Sub ProgrammMitWindowsstartenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProgrammMitWindowsstartenToolStripMenuItem.Click

        If Not RegSecurity.IsAdmin() Then

            RegSecurity.RestartElevated()

        Else

            If Environment.Is64BitOperatingSystem Then
                Dim oRegKey As Microsoft.Win32.RegistryKey
                oRegKey = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Run", True)

                If ProgrammMitWindowsstartenToolStripMenuItem.Checked Then
                    oRegKey.DeleteValue(My.Application.Info.AssemblyName)
                    ProgrammMitWindowsstartenToolStripMenuItem.Checked = True
                Else
                    oRegKey.SetValue(My.Application.Info.AssemblyName, System.Windows.Forms.Application.ExecutablePath & " -a")
                    ProgrammMitWindowsstartenToolStripMenuItem.Checked = True
                End If
                oRegKey.Close()
            Else
                Dim oRegKey As Microsoft.Win32.RegistryKey
                oRegKey = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("SOFTWARE\Microsoft\Windows\CurrentVersion\Run", True)

                If ProgrammMitWindowsstartenToolStripMenuItem.Checked Then
                    oRegKey.DeleteValue(My.Application.Info.AssemblyName)
                    ProgrammMitWindowsstartenToolStripMenuItem.Checked = True
                Else
                    oRegKey.SetValue(My.Application.Info.AssemblyName, System.Windows.Forms.Application.ExecutablePath & " -a")
                    ProgrammMitWindowsstartenToolStripMenuItem.Checked = True
                End If
                oRegKey.Close()
            End If
        End If

    End Sub

    Private Sub frmBirthdayMessenger_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Read_Data()

        If Not Check_Birthday_Today() Then

            'if started by autostart then end
            Dim arguments As [String]() = Environment.GetCommandLineArgs()

            For n As Integer = arguments.GetLowerBound(0) To arguments.GetUpperBound(0)
                If arguments(n) = "-a" Then
                    End
                End If
            Next
        Else
            EintraglöschenToolStripMenuItem.Enabled = True
        End If

        ProgrammMitWindowsstartenToolStripMenuItem.Image = GetUacShieldImage()

    End Sub

    Public Sub Read_Data()

        Dim content As String
        Dim name As String, preName As String, birthDay As Date, info As String
        Dim txtPath As String = Application.StartupPath & "\geburtstage.txt"
        Dim pipePos As Integer

        If Not My.Computer.FileSystem.FileExists(txtPath) Then
            Return
        End If

        content = My.Computer.FileSystem.ReadAllText(txtPath)

        Do While content <> ""

            Try
                'date
                pipePos = content.IndexOf("|")
                birthDay = content.Remove(pipePos)
                content = content.Substring(pipePos + 1)

                'prename
                pipePos = content.IndexOf("|")
                preName = content.Remove(pipePos)
                content = content.Substring(pipePos + 1)

                'name
                pipePos = content.IndexOf("|")
                name = content.Remove(pipePos)
                content = content.Substring(pipePos + 1)

                'info
                pipePos = content.IndexOf(vbCrLf)
                info = content.Remove(pipePos)
                If pipePos < 0 Then
                    content = ""
                Else
                    content = content.Substring(pipePos + vbCrLf.Length)
                End If

                'save in list
                birthdays.Add(New BirthdayInfo(name, preName, birthDay, info))

                calView.AddAnnuallyBoldedDate(birthDay)

            Catch ex As Exception
            End Try

        Loop

        calView.UpdateBoldedDates()
    End Sub

    Public Sub Write_Data()

        Dim content As String = ""
        Dim txtPath As String = Application.StartupPath & "\geburtstage.txt"

        For n As Integer = 0 To birthdays.Count - 1
            content = content & birthdays(n).birthDay & "|" & birthdays(n).preName & "|" & _
                birthdays(n).name & "|" & birthdays(n).info & vbCrLf
        Next n

        Try
            My.Computer.FileSystem.WriteAllText(txtPath, content, False)
        Catch ex As Exception
            MsgBox("Fehler beim Speichern der Geburtstage: " & ex.Message, MsgBoxStyle.Critical, "Fehler")
        End Try

    End Sub

    Private Function Check_Birthday_Today() As Boolean
        Dim result As Boolean = False

        For n As Integer = 0 To birthdays.Count - 1
            If birthdays(n).birthDay.Date = Today.Date Then
                MsgBox("Heute hat " & birthdays(n).preName & " " & birthdays(n).name & " Geburtstag.", _
                       MsgBoxStyle.Information, "Geburtstag heute")
                result = True
            End If
        Next n

        Return result
    End Function

    Private Function Get_Index_At_Date(ByRef chosenDate As Date) As Integer

        Try
            'return index of birthday at this date
            For n As Integer = 0 To birthdays.Count - 1
                If birthdays(n).birthDay.Month = chosenDate.Month And birthdays(n).birthDay.Day = chosenDate.Day Then
                    Return n
                End If
            Next n
        Catch ex As Exception

        End Try

        'if nothing found return -1
        Return -1
    End Function

    Private Sub Save_Changes()

        Dim lastDateBirtDayIndex As Integer = Get_Index_At_Date(lastDate)

        'if entry changed, save changes
        If lastDateBirtDayIndex > -1 Then
            If birthdays(lastDateBirtDayIndex).preName <> txtPreName.Text Or _
                birthdays(lastDateBirtDayIndex).name <> txtname.Text Or _
                birthdays(lastDateBirtDayIndex).info <> rtbAdditional.Text Or _
                birthdays(lastDateBirtDayIndex).birthDay <> lastDate Then
                Dim result As MsgBoxResult = MsgBox("Sollen die Änderungen am letzten Eintrag (" & lastDate & ") gespeichert werden?", vbYesNo, "Änderungen speichern?")
                If result = vbYes Then
                    Actualize_This_Dates_Birthday(lastDate)
                End If
            End If
        ElseIf lastDate.Ticks <> 0 Then    'if entry did not exist, create new (ignore initialize value)
            If txtPreName.Text <> "" Or txtname.Text <> "" Or rtbAdditional.Text <> "" Then
                Actualize_This_Dates_Birthday(lastDate)
            End If
        End If

    End Sub

    Private Sub Actualize_This_Dates_Birthday(ByVal thisDate As Date)
        Dim birthdayIndex As Integer = Get_Index_At_Date(thisDate)

        If birthdayIndex > -1 Then
            birthdays(birthdayIndex) = New BirthdayInfo(txtname.Text, txtPreName.Text, thisDate, rtbAdditional.Text)
        Else
            birthdays.Add(New BirthdayInfo(txtname.Text, txtPreName.Text, thisDate, rtbAdditional.Text))
            calView.AddAnnuallyBoldedDate(thisDate)
        End If

        calView.UpdateBoldedDates()
    End Sub

    Private Sub calView_DateChanged(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DateRangeEventArgs) Handles calView.DateChanged
        Dim birthdayIndex As Integer = Get_Index_At_Date(calView.SelectionRange.Start)

        If lastDate.Month <> calView.SelectionStart.Month Or _
            calView.SelectionStart.Day <> lastDate.Day Then

            Save_Changes()

            If birthdayIndex > -1 Then
                txtname.Text = birthdays(birthdayIndex).name
                txtPreName.Text = birthdays(birthdayIndex).preName
                rtbAdditional.Text = birthdays(birthdayIndex).info
                EintraglöschenToolStripMenuItem.Enabled = True
            Else
                txtname.Text = ""
                txtPreName.Text = ""
                rtbAdditional.Text = ""
                EintraglöschenToolStripMenuItem.Enabled = False
                txtPreName.Focus()
            End If
        End If

        lastDate = calView.SelectionStart
    End Sub

    Private Sub frmBirthdayMessenger_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        Save_Changes()
        Write_Data()
    End Sub

    Private Sub EintraglöschenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EintraglöschenToolStripMenuItem.Click

        Remove_Birthday(calView.SelectionRange.Start)

    End Sub

    Private Sub Remove_Birthday(ByVal birthDay As Date)

        Dim birthdayIndex As Integer = Get_Index_At_Date(birthDay)

        If birthdayIndex > -1 Then
            birthdays.RemoveAt(birthdayIndex)
            txtname.Text = ""
            txtPreName.Text = ""
            rtbAdditional.Text = ""
            EintraglöschenToolStripMenuItem.Enabled = False
            calView.RemoveAnnuallyBoldedDate(calView.SelectionRange.Start)
            calView.UpdateBoldedDates()
        Else
            Beep()
        End If

    End Sub

    Private Sub butSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butSave.Click
        Actualize_This_Dates_Birthday(calView.SelectionRange.Start)
        EintraglöschenToolStripMenuItem.Enabled = True
    End Sub

    Private Sub InDateispeichernToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InDateispeichernToolStripMenuItem.Click
        Write_Data()
    End Sub

    Private Sub OptionenToolStripMenuItem_DropDownOpening(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OptionenToolStripMenuItem.DropDownOpening

        'if already in autostart set checked
        If Environment.Is64BitOperatingSystem Then
            Dim oRegKey As Microsoft.Win32.RegistryKey
            oRegKey = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Run", False)
            If oRegKey.GetValue(My.Application.Info.AssemblyName) Is Nothing Then
                ProgrammMitWindowsstartenToolStripMenuItem.Checked = False
            Else
                ProgrammMitWindowsstartenToolStripMenuItem.Checked = True
            End If
        Else
            Dim oRegKey As Microsoft.Win32.RegistryKey
            oRegKey = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("SOFTWARE\Microsoft\Windows\CurrentVersion\Run", False)
            If oRegKey.GetValue(My.Application.Info.AssemblyName) Is Nothing Then
                ProgrammMitWindowsstartenToolStripMenuItem.Checked = False
            Else
                ProgrammMitWindowsstartenToolStripMenuItem.Checked = True
            End If
        End If
    End Sub

    Private Sub LetzteWocheToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LetzteWocheToolStripMenuItem.Click

        Dim messages As String = ""

        For n As Integer = 0 To birthdays.Count - 1
            'dates without years
            Dim todayDay As Date = New Date(1, Today.Month, Today.Day)
            Dim lastWeek As Date = New Date(1, Today.Month, Today.Day)
            lastWeek = lastWeek.AddDays(-7)
            Dim birthDay As Date = New Date(1, birthdays(n).birthDay.Month, birthdays(n).birthDay.Day)

            'if lastweek < compdate < today | consider not years
            If lastWeek <= birthDay And birthDay <= todayDay Then
                messages = messages & Print_Birthday(n) & vbCrLf
            End If
        Next

        If messages <> "" Then
            MsgBox("Geburtstage in der letzten Woche:" & vbCrLf & messages, MsgBoxStyle.Information, "Letzte Woche")
        Else
            MsgBox("Es gab keine Geburtstage in der letzten Woche.", MsgBoxStyle.Information, "Letzte Woche")
        End If

    End Sub

    Private Sub Nächste2WochenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Nächste2WochenToolStripMenuItem.Click

        Dim messages As String = ""

        For n As Integer = 0 To birthdays.Count - 1
            'dates without years
            Dim todayDay As Date = New Date(1, Today.Month, Today.Day)
            Dim next2Weeks As Date = New Date(1, Today.Month, Today.Day)
            next2Weeks = next2Weeks.AddDays(14)
            Dim birthDay As Date = New Date(1, birthdays(n).birthDay.Month, birthdays(n).birthDay.Day)

            'if lastweek < compdate < today | consider not years
            If next2Weeks >= birthDay And birthDay >= todayDay Then
                messages = messages & Print_Birthday(n) & vbCrLf
            End If
        Next

        If messages <> "" Then
            MsgBox("Geburtstage in den nächsten 2 Wochen:" & vbCrLf & messages, MsgBoxStyle.Information, "Nächste 2 Wochen")
        Else
            MsgBox("Es gibt keine Geburtstage in den nächsten 2 Wochen.", MsgBoxStyle.Information, "Nächste 2 Wochen")
        End If

    End Sub

    Private Function Print_Birthday(ByVal index As Integer) As String

        Return birthdays(index).preName & " " & birthdays(index).name & " hat am " & birthdays(index).birthDay.Month & "." & _
            birthdays(index).birthDay.Day & ". Geburtstag."

    End Function

End Class
